   
SPAWNED_SPRITE_NUM = $12	; Change this if the shotzo_bullet is another sprite number
SPAWNED_CLUSTER_NUM = $15	; Change this if using cluster sprites, and the bullet is another cluster sprite number


RAM_DISP = $1504	; sprite table (don't change)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; INIT and MAIN JSL targets
;
; Uses extra bit: no
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
		    STZ $C2,x		;Facing variable
		    LDA #$20
		    STA $1558,x 	;Timer for shootin' stuff. Game reduces by 1 each frame
		    LDA #$03		;Secondary timer for shooting bursts
		    STA $1534,x 	;shoot 3
                    RTL		

	                dcb "MAIN"			
                    PHB
                    PHK				
                    PLB				
                    JSR SPRITE_ROUTINE	
                    PLB
                    RTL     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPRITE_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPEED_TABLE     	dcb $08,$F8			    ; speeds (right, left)

RETURN      	    RTS

SPRITE_ROUTINE	  	JSR SUB_GFX
                    LDA $14C8,x             ; return if sprite status != 8
                    CMP #$08            	 
                    BNE RETURN           
                    LDA $9D			        ; return if sprites locked
                    BNE RETURN    
                    JSR SUB_OFF_SCREEN_X0   ; only process sprite while on screen

		    JSR SUB_FACE_MARIO	    ; Makes shotzo face mario. Returns $C2,x: 0 = left, 1 = up-left, 2 = up, 3 = up-right, 4 = right
		    
		    JSR SUB_SHOOT_BULLETS   ; Shoots bullets at mario

                    JSL $01A7DC             ; check for mario/sprite contact   
                    RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHICS ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_GFX               
                    
					; 1534 = Bullet count 
					; 1558 = Countdown timer

		    LDA RAM_DISP,x	; displacement timer
		    BEQ END_TIMER
		    DEC A
		    STA RAM_DISP,x
END_TIMER	    LDA $1558,x 
		    BNE NO_KNOCKBACK
		    LDA #$10
		    STA RAM_DISP,x
NO_KNOCKBACK

		    JSR SUB_KNOCKBACK       ; Move shotzo if applicable


		    JSR GET_DRAW_INFO       ; after: Y = index to sprite OAM ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder
		    LDA #$00
		    STA $06
		    LDA RAM_DISP,x		; don't draw smoke if we're not firing
		    BNE CHECK_SCREEN
                    JMP DONT_DRAW_SMOKE


CHECK_SCREEN	    LDA $15A0,x             ; \ Don't draw smoke if offscreen
                    ORA $186C,x             ;  | Has some glitchiness otherwise
                    ORA $15D0,x
                    BEQ DRAW_SMOKE
		    JMP DONT_DRAW_SMOKE

DRAW_SMOKE	    LDA #$01
		    STA $06	    ; sets flag that we drew the smoke tile


		    LDA #$F4	    		; note: circular animations suck
		    STA $1528,x		    ; scratch ram yet again
		    LDA $C2,x
		    BEQ SMOKE_X_OFFSET
		    LDA #$FB
		    STA $1528,x
		    LDA $C2,x
		    CMP #$01
		    BEQ SMOKE_X_OFFSET
		    LDA #$04	
		    STA $1528,x			;determines how much to offset 
		    LDA $C2,x
		    CMP #$02
		    BEQ SMOKE_X_OFFSET
		    LDA #$10
		    STA $1528,x
		    LDA $C2,x
		    CMP #$03
		    BEQ SMOKE_X_OFFSET
		    LDA #$18
		    STA $1528,x
SMOKE_X_OFFSET
		    LDA RAM_DISP,x		; circle animation
		    CMP #$09
		    BCS LARGE_X_SMOKE
		    LDA $1528,x			; 
		    CLC			        ; lower values, more to the left
		    SBC #$04
		    ADC RAM_DISP,x
		    STA $1528,x
		    BRA SMOKE_X_FIN
LARGE_X_SMOKE	    LDA $1528,x		        ; higher values, more to the left
		    CLC
		    ADC #$0D
		    SBC RAM_DISP,x
		    STA $1528,x
SMOKE_X_FIN
		    LDA $1528,x			; Divides diameter by 2
		    CMP #$80
		    BCS NEG_X_SMOKE
		    LDA $1528,x
		    LSR A			; divides by 2
		    STA $1528,x
		    BRA DRAW_X_SMOKE
NEG_X_SMOKE	    LDA $1528,x
		    EOR #$FF			; some bit mainipulation, but just divides by two
		    LSR
		    EOR #$FF
		    STA $1528,x 
DRAW_X_SMOKE        LDA $00                 ; set x position of the tile
		    CLC
		    ADC $1528,x
                    STA $0300,y

		    LDA $1528,x		    ; stores this for spawning bullets later if needed
		    STA $08

;y 
		    STZ $1528,x		    ; scratch ram yet again
		    LDA $C2,x
		    BEQ SMOKE_Y_OFFSET
		    LDA #$F8
		    STA $1528,x
		    LDA $C2,x
		    CMP #$01
		    BEQ SMOKE_Y_OFFSET
		    LDA #$F4
		    STA $1528,x			;determines how much to offset 
		    LDA $C2,x
		    CMP #$02
		    BEQ SMOKE_Y_OFFSET
		    LDA #$F8
		    STA $1528,x
		    LDA $C2,x
		    CMP #$03
		    BEQ SMOKE_Y_OFFSET
		    STZ $1528,x
SMOKE_Y_OFFSET
		    LDA RAM_DISP,x		; circle animation
		    CMP #$04
		    BCC SMALL_Y_SMOKE
		    LDA RAM_DISP,x
		    CMP #$0B
		    BCS LARGE_Y_SMOKE
		    LDA $1528,x
		    CLC		  	        ; lower values, more to the top
		    SBC #$08
		    ADC RAM_DISP,x
		    STA $1528,x
		    BRA SMOKE_Y_FIN
LARGE_Y_SMOKE	    LDA $1528,x
		    CLC		                ; lower values, more to the bottom
		    ADC #$10
		    SBC RAM_DISP,x
		    STA $1528,x
		    BRA SMOKE_Y_FIN
SMALL_Y_SMOKE	    LDA $1528,x			; 
		    CLC			        ; lower values, more to the center
		    SBC RAM_DISP,x
		    STA $1528,x
SMOKE_Y_FIN


		    LDA $1528,x			; Divides diameter by 2
		    CMP #$80
		    BCS NEG_Y_SMOKE
		    LDA $1528,x
		    LSR A			; divides by 2
		    STA $1528,x
		    BRA DRAW_Y_SMOKE
NEG_Y_SMOKE	    LDA $1528,x
		    EOR #$FF			; some bit mainipulation, but just divides by two
		    LSR
		    EOR #$FF
		    STA $1528,x 
DRAW_Y_SMOKE        LDA $01                 ; set y position of the tile
		    CLC
		    ADC $1528,x
                    STA $0301,y

		    LDA $1528,x		    ; stores this for spawning bullets later if needed
		    STA $0A

                    LDA #$0E		    ; set tile number
                    STA $0302,y

                    LDA $15F6,x             ; get sprite palette info
                    ORA $64                 ; add in the priority bits from the level settings
                    STA $0303,y             ; set properties

                    INY                     ; get the index to the next slot of the OAM
                    INY                     ; (this is needed if you wish to draw another tile)
                    INY
                    INY

DONT_DRAW_SMOKE	    LDA $00                 ; set x position of the tile
                    STA $0300,y

		    LDA $01                 ; set y position of the tile
                    STA $0301,y
		

		    STZ $1528,x		    ; scratch ram. If set to non-zero value = flip tile
		    PHY
	 	    LDY #$0A
		    LDA $C2,x
		    BEQ FACING_DONE
		    LDY #$08
		    LDA $C2,x
		    CMP #$01
		    BEQ FACING_DONE
		    LDY #$0C
		    LDA $C2,x
		    CMP #$02
		    BEQ FACING_DONE
		    INC $1528,x		    ; sets the byte. Flips tile
		    LDY #$08
		    LDA $C2,x
		    CMP #$03
		    BEQ FACING_DONE
		    LDY #$0A
FACING_DONE         TYA
	 	    PLY
		    STA $0302,y

		    PHY
                    LDY $15F6,x             ; get sprite palette info
                    LDA $1528,x             ; flip the tile if byte is set
                    BEQ NO_FLIP_1
		    TYA
                    ORA #$40
		    TAY
NO_FLIP_1           TYA
		    ORA $64                 ; add in the priority bits from the level settings
		    PLY
                    STA $0303,y             ; set properties

		    LDA $02	    ; Restores the sprite's x and y so it doesn't slide around the screen
		    STA $E4,x
		    LDA $04
		    STA $D8,x



		    LDA $06
		    BEQ NO_SMOKE		; if we didn't draw smoke, branch

                    LDY #$02                ; #$02 means the tiles are 16x16
                    LDA #$01                ; This means we drew two tiles
                    JSL $01B7B3
                    RTS


NO_SMOKE       	    LDY #$02                ; #$02 means the tiles are 16x16
                    LDA #$00                ; This means we drew one tile
                    JSL $01B7B3
                    RTS			    ; return



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Routine that displaces shotzo when firing. Called from the graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_KNOCKBACK	    
		    LDA $E4,x
		    STA $02	; preserves these values
		    LDA $D8,x
		    STA $04




		    STZ $1528,x

		    LDA $15A0,x             ; \ Don't knockback if offscreen
                    ORA $186C,x             ;  | Looks odd otherwise
                    ORA $15D0,x
                    BEQ DISPLACE_X_0
		    JMP END_X_DISPLACEMENT

DISPLACE_X_0	    LDA RAM_DISP,x
		    BEQ END_X_DISPLACEMENT	; skip all this if the timer's not running
		    LDA $C2,x
		    CMP #$02
		    BEQ END_X_DISPLACEMENT
		    LDA #$FE
		    STA $1528,x
		    LDA $C2,x
		    CMP #$03
		    BCS DISPLACE_X
		    LDA #$02
		    STA $1528,x
DISPLACE_X	    LDA RAM_DISP,x		;
		    CMP #$05			;
		    BCS END_X_DISPLACEMENT	; Move 1 pixel less if timer halfway or below
		    LDA $1528,x			;
		    CMP #$02			;
		    BEQ POS_X_DISP		;
		    INC $1528,x			;
		    BRA END_X_DISPLACEMENT	;
POS_X_DISP	    DEC $1528,x
END_X_DISPLACEMENT  LDA $E4,x               ; set x position of the tile
		    CLC
		    ADC $1528,x
                    STA $E4,x

		    STZ $1528,x

		    LDA $15A0,x             ; \ Don't knockback if offscreen
                    ORA $186C,x             ;  | Looks odd otherwise
                    ORA $15D0,x
                    BEQ DISPLACE_Y_0
		    JMP END_Y_DISPLACEMENT

DISPLACE_Y_0	    LDA RAM_DISP,x
		    BEQ END_Y_DISPLACEMENT	; skip all this if the timer's not running
		    LDA $C2,x
		    CMP #$00
		    BEQ END_Y_DISPLACEMENT
		    LDA $C2,x
		    CMP #$04
		    BEQ END_Y_DISPLACEMENT
		    LDA #$02
		    STA $1528,x
		    LDA RAM_DISP,x		;
		    CMP #$05			; only move down 1 pixel if timer at halfway or below
		    BCS END_Y_DISPLACEMENT	;
		    LDA #$01
		    STA $1528,x
END_Y_DISPLACEMENT  LDA $D8,x                 ; set y position of the tile
		    CLC
		    ADC $1528,x
                    STA $D8,x

		    RTS



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Routine that makes Shotzo face mario
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_FACE_MARIO

		    LDA $14E0,x		    ;\ Sprite x (high)
		    PHA			    ;/
		    LDA $E4,x 		    ;\ Sprite x (low)
		    PHA			    ;/
		    LDA $14D4,x		    ;\ Sprite y (high)
		    PHA			    ;/
		    LDA $D8,x		    ;\ Sprite y (low)
		    PHA			    ;/
		    STZ $C2,x    	    ; Resets bits
		    REP #$20		    ;
		    PLA			    ;\
		    STA $04	    ; | Stores x and y to more readable ram
		    PLA 		    ; |
		    STA $02	    ;/
		    CMP $0094		    ; 
		    BNE UNEQUAL		    ; checks if x's are equal
		    SEP #$20
		    LDA $C2,x
		    ORA #$04		    ; sets third bit if x's equal
		    STA $C2,x
		    REP #$20
		    LDA $02
		    CMP $0094
UNEQUAL		    BCC RIGHT		    ; checks if mario's to the left of the sprite. NOTE TO SELF: find out why this branches as if it were greater-than
		    SEP #$20		    ; 
		    LDA $C2,x		    ; sets first bit if left
		    ORA #$01
		    STA $c2,x
		    REP #$20
RIGHT		    LDA $04
		    DEC A		    ; fixes bug if y's equal.  NOTE TO SELF: Evidence here suggests that these are getting bit flipped (becoming negative) somehow...
		    CMP $0096
		    BCS GO_UP		    ; checks if mario's above the sprite
		    SEP #$20
		    LDA $C2,x		    ;
		    ORA #$02	 	    ; sets second bit if below
		    STA $C2,x		    ;
		    REP #$20
GO_UP		    SEP #$20

		    LDA $C2,x
		    AND #$02
		    BEQ MARIO_ABOVE
		    LDA $C2,x
		    AND #$01
		    BNE BELOW_LEFT
		    LDA #$04		    ; 4 = face right
		    STA $C2,x		    ;
		    RTS
BELOW_LEFT 	    STZ $C2,x		    ; 0 = face left
		    RTS
		
MARIO_ABOVE    	    LDA $C2,x 		;
	    	    AND #$04		; Fixes bug if x's are equal and mario's above
		    BEQ UNEQUAL_X	;	
		    LDA #$02		;
		    STA $C2,x		;
		    RTS
UNEQUAL_X	    LDA $C2,x
	   	    AND #$01
		    BNE ABOVE_LEFT
		    REP #$20
		    LDA $0094
		    CLC
		    SBC $02
		    LSR A		    ; divides by 2
		    STA $02           ; temporarily stores this value here
		    LDA $04
		    CLC
		    SBC $0096
		    STA $06	    ; stores this to scratch ram
		    CMP $02
		    BCS ABOVE_RIGHT_TOP
		    SEP #$20
		    LDA #$04
		    STA $C2,x 		    ; Face right
		    RTS
ABOVE_RIGHT_TOP	    LDA $02	    ;\
		    ASL A		    ; |restores this value
		    STA $02	    ; |
		    LDA $0094		    ; | margin of error: 1
		    CLC			    ; | but who cares
		    SBC $02	    ; | NOTE TO SELF AFTER FIXING BUGS: Really small numbers care
		    STA $02	    ;/
		    LDA $04
		    CLC
		    SBC $0096
		    LSR A		    ; divide by 2
		    STA $04	    ;temporarily stores this value
		    BNE NON_0_Y		 
		    SEP #$20		    ;
		    LDA #$04		    ; fixes bug with really low values of y
		    STA $C2,x		    ;
		    RTS			    ;
NON_0_Y		    LDA $0094
		    CLC
		    SBC $02
		    STA $06
		    CMP $04
		    BCS TOP_RIGHT
		    SEP #$20
		    LDA #$02		    ; Face up
		    STA $C2,x
		    RTS
TOP_RIGHT	    SEP #$20
		    LDA #$03		    ; face up-right
		    STA $C2,x
		    RTS

ABOVE_LEFT	    
		    REP #$20
		    LDA $02
		    CLC
		    SBC $0094
		    LSR A		    ; divides by 2
		    STA $02           ; temporarily stores this value here
		    BNE NOT_ZERO	;
		    SEP #$20		; Fixes bug if this number was 1
		    LDA #$02		; Isn't restored properly and bugs out
		    STA $C2,x		;
		    RTS
NOT_ZERO	    LDA $04
		    CLC
		    SBC $0096
		    CMP $02
		    BCS ABOVE_LEFT_TOP
		    SEP #$20
		    STZ $C2,x 		    ; Face left
		    RTS
ABOVE_LEFT_TOP	    LDA $02	    ;\
		    ASL A		    ; |restores this value
		    STA $02	    ; |
		    LDA $0094		    ; | margin of error: 1
		    CLC			    ; | but who cares
		    ADC $02	    ; | NOTE TO SELF AFTER FIXING BUGS: Really small numbers care
		    STA $02	    ;/
		    LDA $04
		    CLC
		    SBC $0096
		    LSR A		    ; divide by 2
		    STA $04	    ;temporarily stores this value
		    BNE NON_0_Y_2		 
		    SEP #$20		    ;
		    LDA #$00		    ; fixes bug with really low values of y
		    STA $C2,x		    ;
		    RTS		 	    ;
NON_0_Y_2	    LDA $02
		    CLC
		    SBC $0094
		    CMP $04
		    BCS TOP_LEFT
		    SEP #$20
		    LDA #$02		    ; Face up
		    STA $C2,x
		    RTS
TOP_LEFT	    SEP #$20
		    LDA #$01		    ; face up-left
		    STA $C2,x
		    RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Shoots stuff at mario
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN_01	    RTS

SUB_SHOOT_BULLETS

		    LDA $1558,x             ; \ return if it's not time to generate
                    BNE RETURN_01           ; /
                    LDA #$20                ; \ set time till next generation = 20
                    STA $1558,x             ; /
		    DEC $1534,x		    ; Secondary timer for burst shooting.
		    LDA $1534,x
		    BNE CONTINUE_FIRING
		    LDA #$03		    ; fire three shots
		    STA $1534,x
		    LDA #$A0
		    STA $1558,x		    ; Set time for next burst
CONTINUE_FIRING     LDA $15A0,x             ; \ no bullet if off screen
                    ORA $186C,x             ;  |
                    ORA $15D0,x
                    BNE RETURN_01

		LDA #$01
		STA $0B

		   LDA $7FAB10,x           ;\extra bits check
		   AND #$04		    ; | Spawn a bullet stoppable by walls if set
		   BNE SPAWN_2		    ;/

		LDA #$00		; otherwise spawn normal bullet
		STA $0B		

		LDA $7FAB28,x		; extra property byte 1
		BEQ SPAWN_2		; spawn normal sprite if not set
		JMP SPAWN_CLUSTER	; spawn a cluster sprite otherwise
SPAWN_2:
		    JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN_01	    ; / after: Y has index of sprite being generated

		    PHX
		    TYX
                    LDA #SPAWNED_SPRITE_NUM  ; \ set sprite number for new sprite
                    STA $7FAB9E,x           ; / 
		    PLX

                    PHX                     ; \ before: X must have index of sprite being generated
                    TYX                     ; / routine clears *all* old sprite values...
		    JSL $07F7D2		    ; reset sprite properties 
                    JSL $0187A7             ; get table values for custom sprite       
                    LDA #$88	            ; \ mark as initialized
                    STA $7FAB10,x 	    ; / extra bits
                    PLX                     ; call init routine on sprite

	            LDA #$01                ; \ set sprite status for new sprite
                    STA $14C8,y             ; /

		    LDA $08	    ; set x and y
		    CMP #$80		    ; a lot of this stuff is fixing errors that would occur on a screen border
		    BCC POS_X_OFFSET	    ; the purpose is to place the bullet at the end of the cannon's barrel
		    LDA $08
		    BEQ POS_X_OFFSET		; odd bugfix
		    EOR #$FF		    ; turns it positive
		    STA $08	    ; spawn_x and y are set in the graphics routine
		    LDA $00E4,x             ; \ set x position for new sprite
		    CLC 
		    SBC $08	    ; subracts the offset. carry set if NOT overflow
		    STA $00E4,y
                    LDA $14E0,x             ;  |
		    BCS SET_SPAWN_HIGH_X	; carry set if overflow earlier
		    LDA $14E0,x
		    CLC
		    SBC #$01		    ; 
		    BRA SET_SPAWN_HIGH_X
POS_X_OFFSET        LDA $00E4,x
		    CLC
		    ADC $08	    ; adds an offset (determined by graphics routine). carry set if there's overflow
                    STA $00E4,y             ;  |
                    LDA $14E0,x             ;  |
		    BRA SET_SPAWN_HIGH_X	; carry set if overflow earlier
		    LDA $08
		    BEQ SET_SPAWN_HIGH_X	; odd bugfix
		    LDA $14E0,x
		    CLC
		    ADC #$01
SET_SPAWN_HIGH_X    STA $14E0,y             ; /
		    LDA $0A
		    CMP #$80
		    BCC POS_Y_OFFSET
		    LDA $0A
		    BEQ POS_Y_OFFSET		;odd bugfix
		    EOR #$FF		    ; turns it positive
		    CLC
		    ADC #$01
		    STA $0A
		    LDA $00D8,x             ; \ set y position for new sprite
		    CLC
		    SBC $0A	    ; sets carry if NOT overflow
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
		    BCS SET_SPAWN_HIGH_Y	; branches if no overflow
		    LDA $14D4,x
		    CLC
		    SBC #$01
		    BRA SET_SPAWN_HIGH_Y
POS_Y_OFFSET        LDA $00D8,x             ; \ set y position for new sprite
		    CLC
		    ADC $0A	    ; sets carry if overflow
                    STA $00D8,y             ;  |
                    LDA $14D4,x             ;  |
		    BCC SET_SPAWN_HIGH_Y	; branches if no overflow
		    LDA $0A
		    BEQ SET_SPAWN_HIGH_Y	;odd bugfix
		    LDA $14D4,x
		    CLC
		    ADC #$01
SET_SPAWN_HIGH_Y    STA $14D4,y             ; /


		PHX
		LDA $C2,x
		TAX
		    LDA SPAWN_XSPEEDS,x		;
		    STA $B6,y		; sets x and y speed of bullet
		    LDA SPAWN_YSPEEDS,x
		    STA $C2,y		; C2 = bullet's y speed
		PLX

		LDA $0B			; set byte that determines whether bullet is stoppable by walls
		STA $151C,y
		    
RETURN_02           LDA #$09		; play sound
		    STA $1DFC

CLUSTER_SPAWN_RETURN:
		    RTS


SPAWN_CLUSTER:
	LDY #$13		; get free cluster sprite num
CLUSTER1:
	LDA $1892,y		;
	BEQ CLUSTER_GOTONE	; if 0, got one
	DEY			; else keep looping
	BPL CLUSTER1
	BRA CLUSTER_SPAWN_RETURN	; if none available, return
CLUSTER_GOTONE:

	LDA #SPAWNED_CLUSTER_NUM	; set cluster sprite number
	STA $1892,y			;

	LDA $0A		; y offset
	BMI CLUSTER_NEGY	; negative y displacement needs different calculations...
	CLC
	ADC $D8,x	; shotzo Y (low)
	STA $1E02,y		; set cluster sprite y (low)
	LDA $14D4,X		; shotzo y (high)
	ADC #$00		; screen boundary thingy
	STA $1E2A,y		; set cluster sprite y (high)
	BRA CLUSTER_YCONT	; continue
CLUSTER_NEGY:
	CLC
	ADC $D8,x
	STA $1E02,Y		; same as above...
	LDA $14D4,x
	ADC #$FF
	STA $1E2A,Y
CLUSTER_YCONT:

	LDA $08		; x offset
	BMI CLUSTER_NEGX	; negative x needs different stuff too...
	LDA $E4,x	; shotzo x (low)
	SEC
	SBC $08	
	STA $1E16,y	; cluster x (low)
	LDA $14E0,x	; shotzo x (high)
	SBC #$00
	STA $1E3E,y	; cluster x (high)
	BRA CLUSTER_XCONT	; continue
CLUSTER_NEGX:
	LDA $E4,x
	SEC
	SBC $08
	STA $1E16,y
	LDA $14E0,x
	SBC #$FF
	STA $1E3E,y
CLUSTER_XCONT:
	
		PHX
		LDA $C2,x
		TAX
		    LDA SPAWN_YSPEEDS,x		;
		    STA $1E52,y		; sets x and y speed of bullet
		    LDA SPAWN_XSPEEDS,x	; 1e52 = y speed
		    STA $1E66,y		; 1e66 = x speed
		LDA #$00	; clear...
		STA $1E7A,y	; accumulating fraction bits for y speed
		STA $1E8E,y	; same for x speed
		PLX

	LDA #$01	; make cluster sprites run
	STA $18B8

	JMP RETURN_02	; finish and play sound


SPAWN_XSPEEDS:
	db $E8,$F0,$00,$10,$18
SPAWN_YSPEEDS:
	db $00,$F0,$E8,$F0,$00




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ROUTINES FROM THE LIBRARY ARE PASTED BELOW
; You should never have to modify this code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;       Y = index to sprite OAM ($300)
;       $00 = sprite x position relative to screen boarder
;       $01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPR_T12             dcb $40,$B0
SPR_T13             dcb $01,$FF
SPR_T14             dcb $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
		            dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15             dcb $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
					dcb $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6   LDA #$0C                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X7   LDA #$0E                ;  |
STORE_03			STA $03					;  |            
					BRA START_SUB			;  |
SUB_OFF_SCREEN_X0   STZ $03					; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_35           RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA.W $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_HORZ_POS
; This routine determines which side of the sprite Mario is on.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B817
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS		LDY #$00				;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
					LDA $94					;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
					SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
					SBC $E4,x				;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
					STA $0F					;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
					LDA $95					;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
					SBC $14E0,x				;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
					BPL SPR_L16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
					INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
SPR_L16				RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642


